! Copyright 1999 Stanford University
!All rights reserved
!
!Author: Sergey Fomel
!
module createnhelixmod_smp 
! Create non-stationary helix filter lags and mis

  use createhelixmod
  use nhelix

  implicit none
  contains
  function createnhelix_smp( nd, center, gap, na, pch, nmis) result (nsaa)
    type( nfilter)                     :: nsaa   ! needed by nhelicon
    integer, dimension(:), intent(in)  :: nd, na ! data and filter axes
    integer, dimension(:), intent(in)  :: center ! normally (na1/2,na2/2,...,1)
    integer, dimension(:), intent(in)  :: gap    ! normally ( 0,   0,  0,...,0)
    integer, dimension(:), intent(in)  :: pch	 ! (prod(nd)) patching
    real,    dimension(:), pointer     :: nmis	
    type( filter)                      :: aa
    integer                            :: n123, np, ip
    integer, dimension(:), allocatable :: nh

    aa = createhelix( nd, center, gap, na)

    n123 = product( nd)
    np = maxval(pch)

    allocate (nh (np))
    nh = size (aa%lag)
    call nallocate( nsaa, nh, pch)

    do ip = 1, np 
      nsaa%hlx( ip)%lag = aa%lag
    end do 

    call deallocatehelix (aa)

    allocate(nsaa%mis(n123))
    nsaa%mis = .false.
    where (nmis==0.) nsaa%mis=.true.

    deallocate(nh)

  end function createnhelix_smp

end module createnhelixmod_smp
