module hell_row_mod

use row_mod
use npolydiv
use npolydiv2
use polydiv
use polydiv2

implicit none

integer, private :: nd
real,    private :: mu

contains
  
  subroutine init_hell_row( nd_in, mu_in)
    integer :: nd_in
    real    :: mu_in
    nd = nd_in
    mu = mu_in
  end subroutine init_hell_row

  integer function hell_row_op( adj, add, model, data)
    logical            :: adj,add
    real, dimension(:) :: model, data

    call row2( npolydiv2_lop, npolydiv_lop, adj, add, model(1:nd), &
         & model(nd+1:), data, mu)
    hell_row_op = 0
  end function hell_row_op
  
  integer function hell_row_op_smp( adj, add, model, data)
    logical            :: adj,add
    real, dimension(:) :: model, data

    call row2( polydiv2_lop, polydiv_lop, adj, add, model(1:nd), &
         & model(nd+1:), data, mu)
    hell_row_op_smp = 0
  end function hell_row_op_smp

end module hell_row_mod
