module pef_pat  
! Find prediction-error filter (helix magic)
  use hconest
  use cgstep_mod
  use solver_smp_mod
  use solver2_mod
  implicit none
  contains
  subroutine find_pef_pat( dd, aa, niter, wt)
    optional                       :: wt
    integer,          intent( in)  :: niter        
    ! number of iterations
    type( filter)                  :: aa           ! filter
    real,    dimension(:), pointer :: dd           ! input data
    real,    dimension(:)          :: wt
    call hconest_init( dd, aa)
    if (present(wt)) then
!       call solver_smp(m=aa%flt, d=-dd, Fop=hconest_lop, stepper=cgstep,&
!       & niter=niter, m0=aa%flt)
       call solver(hconest_lop,cgstep,x=aa%flt, dat=-dd,&
       & niter=niter,x0=aa%flt,wt=wt)
    else
!       call solver_smp(m=aa%flt, d=-dd, Fop=hconest_lop, stepper=cgstep,&
!       & niter=niter, m0=aa%flt)
       call solver(hconest_lop,cgstep,x=aa%flt, dat=-dd,&
       & niter=niter,x0=aa%flt)
    end if
    call cgstep_close()
  end subroutine find_pef_pat
end module pef_pat
