module row_mod

  implicit none
  logical, parameter, private :: T = .true., F = .false.  

contains

  subroutine row2 (oper1, oper2, adj, add, mod1, mod2, dat, mu)
    interface
       function oper1 (adj, add, mod, dat) result (stat)
         integer              :: stat
         logical, intent (in) :: adj, add
         real, dimension (:)  :: mod, dat
       end function oper1
       function oper2 (adj, add, mod, dat) result (stat)
         integer    :: stat
         logical, intent (in) :: adj, add
         real, dimension (:)  :: mod, dat
       end function oper2
    end interface
    logical, intent (in)  :: adj, add
    real, dimension (:)   :: mod1, mod2, dat
    real                  :: mu 

    real, dimension(:), allocatable :: tmp

    integer               :: stat1, stat2
    real                  :: eps1, eps2

    allocate(tmp(size(dat)))

    if (adj) then

       stat1 = oper1 (T, add, mod1, dat)
       mod1  = mu*mod1
       stat2 = oper2 (T, add, mod2, dat)

    else

       tmp = 0.

       stat1 = oper1 (F, add, mod1, tmp)

       if (add) then
          dat = mu*tmp+dat
       else
          dat = mu*tmp
       end if


       stat2 = oper2 (F,   T, mod2, dat)

    end if

    deallocate(tmp)

  end subroutine row2

end module row_mod










