program compute_rms

  use sep

  implicit none

  integer n1,n2,n3
  integer ndim
  integer, dimension(:), allocatable :: n
  real   , dimension(:), allocatable :: o, d, data, out
  integer  nwin, nfast, nslow, i, j, beg, end
  real oslow, dslow

  call initpar()
  call sep_init (SOURCE)
  ndim=sep_dimension()
  
  allocate(n(ndim))
  allocate(o(ndim))
  allocate(d(ndim))
    
  call from_history('n',n)
  call from_history('o',o)
  call from_history('d',d)

  if (ndim==2) then
     nfast=n(1)
     nslow=n(2)
     dslow=d(2)
     oslow=o(2)
  else
     nfast=n(1)*n(2)
     nslow=n(3)
     dslow=d(3)
     oslow=o(3)
  end if

  call from_param('nwin',nwin,int(nslow/20))
  if (nwin.gt.nslow) then
     write(0,*) 'nwin is too big, takes default value',int(nslow)/20
     nwin=int(nslow/20)
  end if
  
  allocate(data(nslow*nfast))
  allocate(out(nslow))

  call sep_read(data)
  
  write(0,*) 'nwin',nwin
  write(0,*) 'nslow',nslow
  write(0,*) 'nfast',nfast

  do i=1,nslow
     beg=max(0,i-nwin+1)*nfast+1
     end=min(nslow,i+nwin-1)*nfast
     out(i)=sum(dprod(data(beg:end),data(beg:end)))/(end-beg+1)
  end do
  
  call to_history('n1',nslow)
  call to_history('d1',dslow)
  call to_history('o1',oslow)
  call to_history('n2',1)
  call to_history('n3',1)
  
  call sep_write(out)

  deallocate(data,out,n,d,o)

end program compute_rms
